'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

function Container(props) {
  return React.createElement(
    "div",
    { className: "container" },
    props.children
  );
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var classnames = createCommonjsModule(function (module) {
/*!
  Copyright (c) 2016 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
/* global define */

(function () {
	var hasOwn = {}.hasOwnProperty;

	function classNames () {
		var classes = [];

		for (var i = 0; i < arguments.length; i++) {
			var arg = arguments[i];
			if (!arg) continue;

			var argType = typeof arg;

			if (argType === 'string' || argType === 'number') {
				classes.push(arg);
			} else if (Array.isArray(arg)) {
				classes.push(classNames.apply(null, arg));
			} else if (argType === 'object') {
				for (var key in arg) {
					if (hasOwn.call(arg, key) && arg[key]) {
						classes.push(key);
					}
				}
			}
		}

		return classes.join(' ');
	}

	if ('object' !== 'undefined' && module.exports) {
		module.exports = classNames;
	} else if (typeof undefined === 'function' && typeof undefined.amd === 'object' && undefined.amd) {
		// register as 'classnames', consistent with npm package name
		undefined('classnames', [], function () {
			return classNames;
		});
	} else {
		window.classNames = classNames;
	}
}());
});

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};









var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

function GridRow(_ref) {
  var _cn;

  var className = _ref.className,
      children = _ref.children,
      cards = _ref.cards,
      deck = _ref.deck,
      _ref$gutters = _ref.gutters,
      gutters = _ref$gutters === undefined ? "" : _ref$gutters,
      _ref$alignItems = _ref.alignItems,
      alignItems = _ref$alignItems === undefined ? "" : _ref$alignItems;

  var classes = classnames("row", (_cn = {
    row: true,
    "row-cards": cards,
    "row-deck": deck
  }, defineProperty(_cn, "gutters-" + gutters, gutters), defineProperty(_cn, "align-items-" + alignItems, alignItems), _cn), className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

GridRow.displayName = "Grid.Row";

function GridCol(_ref) {
  var _cn;

  var className = _ref.className,
      children = _ref.children,
      _ref$width = _ref.width,
      width = _ref$width === undefined ? 0 : _ref$width,
      _ref$sm = _ref.sm,
      sm = _ref$sm === undefined ? 0 : _ref$sm,
      _ref$md = _ref.md,
      md = _ref$md === undefined ? 0 : _ref$md,
      _ref$lg = _ref.lg,
      lg = _ref$lg === undefined ? 0 : _ref$lg,
      _ref$xl = _ref.xl,
      xl = _ref$xl === undefined ? 0 : _ref$xl,
      smAuto = _ref.smAuto,
      mdAuto = _ref.mdAuto,
      lgAuto = _ref.lgAuto,
      xlAuto = _ref.xlAuto,
      auto = _ref.auto;

  var classes = classnames((_cn = {
    col: true
  }, defineProperty(_cn, "col-" + width, width), defineProperty(_cn, "col-sm-" + sm, sm), defineProperty(_cn, "col-sm-auto", smAuto), defineProperty(_cn, "col-md-" + md, md), defineProperty(_cn, "col-md-auto", mdAuto), defineProperty(_cn, "col-lg-" + lg, lg), defineProperty(_cn, "col-lg-auto", lgAuto), defineProperty(_cn, "col-xl-" + xl, xl), defineProperty(_cn, "col-xl-auto", xlAuto), defineProperty(_cn, "col-auto", auto), _cn), className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

GridCol.displayName = "Grid.Col";

var Grid = {
  Row: GridRow,
  Col: GridCol
};

function H1(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("mt-0 mb-4", className);
  return React.createElement(
    Header,
    { RootComponent: "h1", className: classes, size: 1 },
    children
  );
}

H1.displayName = "Header.H1";

function H2(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("mt-0 mb-4", className);
  return React.createElement(
    Header,
    { RootComponent: "h2", className: classes, size: 2 },
    children
  );
}

H2.displayName = "Header.H2";

function H3(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("mt-0 mb-4", className);
  return React.createElement(
    Header,
    { RootComponent: "h3", className: classes, size: 3 },
    children
  );
}

H3.displayName = "Header.H3";

function H4(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("mt-0 mb-4", className);
  return React.createElement(
    Header,
    { RootComponent: "h4", className: classes, size: 4 },
    children
  );
}

H4.displayName = "Header.H4";

function H5(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("mt-0 mb-4", className);
  return React.createElement(
    Header,
    { RootComponent: "h5", className: classes, size: 5 },
    children
  );
}

H5.displayName = "Header.H5";

function Header(_ref) {
  var RootComponent = _ref.RootComponent,
      className = _ref.className,
      children = _ref.children,
      _ref$size = _ref.size,
      size = _ref$size === undefined ? 1 : _ref$size;

  var classes = classnames("h" + size, className);
  var Component$$1 = RootComponent || "div";
  return React.createElement(
    Component$$1,
    { className: classes },
    children
  );
}

Header.H1 = H1;
Header.H2 = H2;
Header.H3 = H3;
Header.H4 = H4;
Header.H5 = H5;

var SiteHeader = function SiteHeader(_ref) {
  var children = _ref.children;
  return React.createElement(
    "div",
    { className: "header py-4" },
    React.createElement(
      Container,
      null,
      React.createElement(
        "div",
        { className: "d-flex" },
        children
      )
    )
  );
};

SiteHeader.displayName = "Site.Header";

var SiteNav = function SiteNav(props) {
  return React.createElement(
    "div",
    { className: "header collapse d-lg-flex p-0", id: "headerMenuCollapse" },
    React.createElement(
      Container,
      null,
      props.children
    )
  );
};

SiteNav.displayName = "Site.Nav";

var SiteLogo = function SiteLogo(props) {
  return React.createElement(
    "a",
    { className: "header-brand", href: props.href },
    React.createElement("img", { src: props.src, className: "header-brand-img", alt: props.alt })
  );
};

SiteLogo.displayName = "Site.Logo";

var SiteFooter = function SiteFooter() {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(
      "div",
      { className: "footer" },
      React.createElement(
        Container,
        null,
        React.createElement(
          Grid.Row,
          null,
          React.createElement(
            Grid.Col,
            { lg: 8 },
            React.createElement(
              Grid.Row,
              null,
              React.createElement(
                Grid.Col,
                { width: 6, md: 3 },
                React.createElement(
                  List,
                  { unstyled: true, className: "mb-0" },
                  React.createElement(
                    List.Item,
                    null,
                    React.createElement(
                      "a",
                      null,
                      "First link"
                    )
                  ),
                  React.createElement(
                    List.Item,
                    null,
                    React.createElement(
                      "a",
                      null,
                      "Second link"
                    )
                  )
                )
              ),
              React.createElement(
                Grid.Col,
                { width: 6, md: 3 },
                React.createElement(
                  List,
                  { unstyled: true, className: "mb-0" },
                  React.createElement(
                    List.Item,
                    null,
                    React.createElement(
                      "a",
                      null,
                      "Third link"
                    )
                  ),
                  React.createElement(
                    List.Item,
                    null,
                    React.createElement(
                      "a",
                      null,
                      "Fourth link"
                    )
                  )
                )
              ),
              React.createElement(
                Grid.Col,
                { width: 6, md: 3 },
                React.createElement(
                  List,
                  { unstyled: true, className: "mb-0" },
                  React.createElement(
                    List.Item,
                    null,
                    React.createElement(
                      "a",
                      null,
                      "Fifth link"
                    )
                  ),
                  React.createElement(
                    List.Item,
                    null,
                    React.createElement(
                      "a",
                      null,
                      "Sixth link"
                    )
                  )
                )
              ),
              React.createElement(
                Grid.Col,
                { width: 6, md: 3 },
                React.createElement(
                  List,
                  { unstyled: true, className: "mb-0" },
                  React.createElement(
                    List.Item,
                    null,
                    React.createElement(
                      "a",
                      null,
                      "Other link"
                    )
                  ),
                  React.createElement(
                    List.Item,
                    null,
                    React.createElement(
                      "a",
                      null,
                      "Last link"
                    )
                  )
                )
              )
            )
          ),
          React.createElement(
            Grid.Col,
            { lg: 4, className: "mt-4 mt-lg-0" },
            "Premium and Open Source dashboard template with responsive and high quality UI. For Free!"
          )
        )
      )
    ),
    React.createElement(
      "footer",
      { className: "footer" },
      React.createElement(
        Container,
        null,
        React.createElement(
          Grid.Row,
          { className: "align-items-center flex-row-reverse" },
          React.createElement(
            Grid.Col,
            { auto: true, className: "ml-auto" },
            React.createElement(
              Grid.Row,
              { className: "align-items-center" },
              React.createElement(
                Grid.Col,
                { auto: true },
                React.createElement(
                  List,
                  { className: "list-inline list-inline-dots mb-0" },
                  React.createElement(
                    List.Item,
                    { className: "list-inline-item" },
                    React.createElement(
                      "a",
                      { href: "./docs/index.html" },
                      "Documentation"
                    )
                  ),
                  React.createElement(
                    List.Item,
                    { className: "list-inline-item" },
                    React.createElement(
                      "a",
                      { href: "./faq.html" },
                      "FAQ"
                    )
                  )
                )
              ),
              React.createElement(
                Grid.Col,
                { auto: true },
                React.createElement(
                  Button,
                  {
                    href: "https://github.com/tabler/tabler-react",
                    size: "sm",
                    outline: true,
                    color: "primary",
                    RootComponent: "a"
                  },
                  "Source code"
                )
              )
            )
          ),
          React.createElement(
            Grid.Col,
            { width: 12, lgAuto: true, className: "mt-3 mt-lg-0 text-center" },
            "Copyright \xA9 2018",
            React.createElement(
              "a",
              { href: "." },
              " Tabler-react"
            ),
            ". Theme by",
            React.createElement(
              "a",
              {
                href: "https://codecalm.net",
                target: "_blank",
                rel: "noopener noreferrer"
              },
              " ",
              "codecalm.net"
            ),
            " ",
            "All rights reserved."
          )
        )
      )
    )
  );
};

SiteFooter.displayName = "Site.Footer";

var Site = {
  Header: SiteHeader,
  Navbar: SiteNav,
  Logo: SiteLogo,
  Footer: SiteFooter
};

function CardHeader(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("card-header", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

CardHeader.displayName = "Card.Header";

function CardTitle(_ref) {
  var className = _ref.className,
      children = _ref.children,
      RootComponent = _ref.RootComponent;

  var classes = classnames("card-title", className);
  var Component$$1 = RootComponent || "h3";
  return React.createElement(
    Component$$1,
    { className: classes },
    children
  );
}

CardTitle.displayName = "Card.Title";

function CardBody(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("card-body", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

CardBody.displayName = "Card.Body";

function CardOptions(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("card-options", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

CardOptions.displayName = "Card.Options";

function CardOptionsItem(_ref) {
  var className = _ref.className,
      children = _ref.children,
      icon = _ref.icon,
      type = _ref.type,
      onClick = _ref.onClick;

  var classes = classnames({
    "card-options-collapse": type === "collapse",
    "card-options-remove": type === "close",
    "card-options-fullscreen": type === "fullscreen"
  }, className);

  var dataToggle = function () {
    switch (type) {
      case "collapse":
        return "card-collapse";
      case "close":
        return "card-remove";
      case "fullscreen":
        return "card-remove";
      default:
        return "";
    }
  }();

  var iconName = function () {
    if (icon) {
      return icon;
    }
    switch (type) {
      case "collapse":
        return "chevron-up";
      case "close":
        return "x";
      case "fullscreen":
        return "maximize";
      default:
        return "";
    }
  }();

  return React.createElement(
    "a",
    { className: classes, "data-toggle": dataToggle, onClick: onClick },
    React.createElement(Icon, { name: iconName })
  );
}

CardOptionsItem.displayName = "Card.OptionsItem";

function CardStatus(_ref) {
  var _cn;

  var className = _ref.className,
      children = _ref.children,
      color = _ref.color,
      side = _ref.side;

  var classes = classnames((_cn = {
    "card-status": true
  }, defineProperty(_cn, "bg-" + color, true), defineProperty(_cn, "card-status-left", side), _cn), className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

CardStatus.displayName = "Card.Status";

function CardAlert(_ref) {
  var className = _ref.className,
      children = _ref.children,
      color = _ref.color;

  var classes = classnames("card-alert alert alert-" + color + " mb-0", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

CardAlert.displayName = "Card.Alert";

function CardFooter(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("card-footer", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

CardFooter.displayName = "Card.Footer";

var Card = function (_React$PureComponent) {
  inherits(Card, _React$PureComponent);

  function Card() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, Card);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = Card.__proto__ || Object.getPrototypeOf(Card)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isClosed: _this.props.isClosed || false,
      isCollapsed: _this.props.isCollapsed || false,
      isFullscreen: false
    }, _this.handleCloseOnClick = function () {
      _this.setState(function (s) {
        return {
          isClosed: !s.isClosed
        };
      });
    }, _this.handleCollapseOnClick = function () {
      _this.setState(function (s) {
        return {
          isCollapsed: !s.isCollapsed
        };
      });
    }, _this.handleFullscreenOnClick = function () {
      _this.setState(function (s) {
        return {
          isFullscreen: !s.isFullscreen
        };
      });
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(Card, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          className = _props.className,
          children = _props.children,
          RootComponent = _props.RootComponent,
          title = _props.title,
          body = _props.body,
          options = _props.options,
          isCollapsible = _props.isCollapsible,
          isClosable = _props.isClosable,
          isFullscreenable = _props.isFullscreenable,
          statusColor = _props.statusColor,
          statusSide = _props.statusSide,
          alert = _props.alert,
          alertColor = _props.alertColor,
          footer = _props.footer;
      var _state = this.state,
          isClosed = _state.isClosed,
          isCollapsed = _state.isCollapsed,
          isFullscreen = _state.isFullscreen;

      if (isClosed) {
        return null;
      }
      var classes = classnames({
        card: true,
        "card-collapsed": isCollapsed,
        "card-fullscreen": isFullscreen
      }, className);
      var Component$$1 = RootComponent || "div";

      var card_options = (options || isCollapsible || isClosable) && React.createElement(
        Card.Options,
        null,
        options,
        isCollapsible && React.createElement(Card.OptionsItem, {
          onClick: this.handleCollapseOnClick,
          type: "collapse"
        }),
        isFullscreenable && React.createElement(Card.OptionsItem, {
          type: "fullscreen",
          onClick: this.handleFullscreenOnClick
        }),
        isClosable && React.createElement(Card.OptionsItem, { type: "close", onClick: this.handleCloseOnClick })
      );

      var card_status = statusColor && React.createElement(Card.Status, { color: statusColor, side: statusSide });

      var card_alert = alert && alertColor && React.createElement(
        Card.Alert,
        { color: alertColor },
        alert
      );

      var card_header = title && React.createElement(
        Card.Header,
        null,
        React.createElement(
          Card.Title,
          null,
          title
        ),
        card_options
      );

      var card_body = body && React.createElement(
        Card.Body,
        null,
        body
      );

      var card_footer = footer && React.createElement(
        Card.Footer,
        null,
        footer
      );

      if (card_header !== null || card_body !== null) {
        return React.createElement(
          Component$$1,
          { className: classes },
          card_status,
          card_header,
          card_alert,
          card_body || children,
          card_footer
        );
      } else {
        return React.createElement(
          Component$$1,
          { className: classes },
          children
        );
      }
    }
  }]);
  return Card;
}(React.PureComponent);

Card.Header = CardHeader;
Card.Body = CardBody;
Card.Title = CardTitle;
Card.Options = CardOptions;
Card.OptionsItem = CardOptionsItem;
Card.Status = CardStatus;
Card.Alert = CardAlert;
Card.Footer = CardFooter;

function PageMain(_ref) {
  var children = _ref.children;

  return React.createElement(
    "div",
    { className: "page-main" },
    children
  );
}

PageMain.displayName = "Page.Main";

function PageContent(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("page-content", className);
  return React.createElement(
    "div",
    { className: classes },
    React.createElement(
      Container,
      null,
      children
    )
  );
}

PageContent.displayName = "Page.Content";

function PageTitle(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("page-title", className);
  return React.createElement(
    "h1",
    { className: classes },
    children
  );
}

PageTitle.displayName = "Page.Title";

function PageHeader(_ref) {
  var children = _ref.children;

  return React.createElement(
    "div",
    { className: "page-header" },
    React.createElement(
      PageTitle,
      null,
      children
    )
  );
}

PageHeader.displayName = "Page.Header";

function PageContentWithSidebar(_ref) {
  var children = _ref.children,
      header = _ref.header,
      sidebar = _ref.sidebar;

  return React.createElement(
    Page.Content,
    null,
    header,
    React.createElement(
      Grid.Row,
      null,
      React.createElement(
        Grid.Col,
        { lg: 3, className: "order-lg-1 mb-4" },
        sidebar
      ),
      React.createElement(
        Grid.Col,
        { lg: 9 },
        children
      )
    )
  );
}

PageContentWithSidebar.displayName = "Page.ContentWithSidebar";

function PageCard(_ref) {
  var children = _ref.children,
      title = _ref.title,
      header = _ref.header,
      footer = _ref.footer,
      RootComponent = _ref.RootComponent;

  return React.createElement(
    "div",
    { className: "my-3 my-md-5" },
    React.createElement(
      Container,
      null,
      React.createElement(
        Grid.Row,
        null,
        React.createElement(
          Grid.Col,
          { width: 12 },
          React.createElement(
            Card,
            { RootComponent: RootComponent },
            title && React.createElement(
              Card.Header,
              null,
              React.createElement(
                Card.Title,
                null,
                title
              )
            ),
            header,
            React.createElement(
              Card.Body,
              null,
              children
            ),
            footer
          )
        )
      )
    )
  );
}

PageCard.displayName = "Page.Card";

function Page(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("page", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

Page.Main = PageMain;
Page.Content = PageContent;
Page.Header = PageHeader;
Page.ContentWithSidebar = PageContentWithSidebar;
Page.Card = PageCard;
Page.Title = PageTitle;

function FormLabel(_ref) {
  var className = _ref.className,
      aside = _ref.aside,
      children = _ref.children;

  var classes = classnames("form-label", className);
  return React.createElement(
    "label",
    { className: classes },
    aside && React.createElement(
      "span",
      { className: "form-label-small" },
      aside
    ),
    children
  );
}

FormLabel.displayName = "Form.Label";

function FormGroup(_ref) {
  var className = _ref.className,
      children = _ref.children,
      label = _ref.label,
      isRequired = _ref.isRequired;

  var classes = classnames("form-group", className);
  return React.createElement(
    "div",
    { className: classes },
    !label ? null : typeof label === "string" ? React.createElement(
      FormLabel,
      null,
      label,
      isRequired && React.createElement(
        "span",
        { "class": "form-required" },
        "*"
      )
    ) : label,
    children
  );
}

FormGroup.displayName = "Form.Group";

function FormInput(props) {
  var className = props.className,
      name = props.name,
      icon = props.icon,
      _props$position = props.position,
      position = _props$position === undefined ? "prepend" : _props$position,
      valid = props.valid,
      tick = props.tick,
      invalid = props.invalid,
      cross = props.cross,
      feedback = props.feedback,
      placeholder = props.placeholder,
      value = props.value,
      checked = props.checked,
      onChange = props.onChange,
      disabled = props.disabled,
      readOnly = props.readOnly;

  var type = props.type || "text";

  var classes = classnames({
    "form-control": type !== "checkbox" && type !== "radio",
    "custom-control-input": type === "checkbox" || type === "radio",
    "is-valid": valid,
    "state-valid": tick,
    "is-invalid": invalid,
    "state-invalid": cross
  }, className);
  return !icon ? React.createElement(
    React.Fragment,
    null,
    type === "checkbox" || type === "radio" ? React.createElement("input", {
      name: name,
      className: classes,
      type: type,
      placeholder: placeholder,
      checked: checked,
      value: value,
      disabled: disabled,
      readOnly: readOnly,
      onChange: onChange
    }) : React.createElement("input", {
      name: name,
      className: classes,
      type: type,
      placeholder: placeholder,
      value: value,
      disabled: disabled,
      readOnly: readOnly,
      onChange: onChange
    }),
    feedback && (invalid || cross) && React.createElement(
      "span",
      { className: "invalid-feedback" },
      feedback
    )
  ) : React.createElement(
    "div",
    { className: "input-icon" },
    position === "prepend" && React.createElement(
      "span",
      { className: "input-icon-addon" },
      React.createElement(Icon, { name: icon })
    ),
    React.createElement("input", {
      name: name,
      className: classes,
      type: type,
      placeholder: placeholder,
      value: value,
      disabled: disabled,
      readOnly: readOnly,
      onChange: onChange
    }),
    position === "append" && React.createElement(
      "span",
      { className: "input-icon-addon" },
      React.createElement(Icon, { name: icon })
    )
  );
}

FormInput.displayName = "Form.Input";

function FormStaticText(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("form-control-plaintext", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

FormStaticText.displayName = "Form.StaticText";

function FormTextarea(_ref) {
  var className = _ref.className,
      name = _ref.name,
      placeholder = _ref.placeholder,
      defaultValue = _ref.defaultValue,
      value = _ref.value,
      disabled = _ref.disabled,
      rows = _ref.rows;

  var classes = classnames("form-control", className);
  return React.createElement("textarea", {
    className: classes,
    name: name,
    placeholder: placeholder,
    defaultValue: defaultValue,
    value: value,
    disabled: disabled,
    rows: rows
  });
}

FormTextarea.displayName = "Form.Textarea";

function FormImageCheck(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("gutters-sm", className);
  return React.createElement(
    Grid.Row,
    { className: classes },
    children
  );
}

FormImageCheck.displayName = "Form.ImageCheck";

function FormImageCheckItem(_ref) {
  var className = _ref.className,
      _ref$col = _ref.col;
  _ref$col = _ref$col === undefined ? {} : _ref$col;
  var _ref$col$width = _ref$col.width,
      width = _ref$col$width === undefined ? 6 : _ref$col$width,
      _ref$col$sm = _ref$col.sm,
      sm = _ref$col$sm === undefined ? 4 : _ref$col$sm,
      _ref$col$md = _ref$col.md,
      md = _ref$col$md === undefined ? 0 : _ref$col$md,
      _ref$col$lg = _ref$col.lg,
      lg = _ref$col$lg === undefined ? 0 : _ref$col$lg,
      imageURL = _ref.imageURL,
      value = _ref.value;

  return React.createElement(
    Grid.Col,
    { width: width, sm: sm, md: md, lg: lg },
    React.createElement(
      "label",
      { className: "imagecheck mb-4" },
      React.createElement("input", {
        name: "imagecheck",
        type: "checkbox",
        value: value,
        className: "imagecheck-input"
      }),
      React.createElement(
        "figure",
        { className: "imagecheck-figure" },
        React.createElement("img", { src: imageURL, alt: "Select", className: "imagecheck-image" })
      )
    )
  );
}

FormImageCheckItem.displayName = "Form.ImageCheckItem";

function FormColorCheck(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("gutters-xs", className);
  return React.createElement(
    Grid.Row,
    { className: classes },
    children
  );
}

FormColorCheck.displayName = "Form.ColorCheck";

function FormColorCheckItem(_ref) {
  var className = _ref.className,
      color = _ref.color;

  var classes = classnames(className);
  return React.createElement(
    Grid.Col,
    { auto: true, className: classes },
    React.createElement(
      "label",
      { className: "colorinput" },
      React.createElement("input", {
        name: "color",
        type: "checkbox",
        value: color,
        className: "colorinput-input"
      }),
      React.createElement("span", { className: "colorinput-color bg-" + color })
    )
  );
}

FormColorCheckItem.displayName = "Form.ColorCheckItem";

function FormInputGroup(_ref) {
  var className = _ref.className,
      children = _ref.children,
      append = _ref.append,
      prepend = _ref.prepend,
      RootComponent = _ref.RootComponent;

  var classes = classnames({
    "input-group": !append && !prepend,
    "input-group-append": append,
    "input-group-prepend": prepend
  }, className);
  var Component$$1 = RootComponent || "div";
  return React.createElement(
    Component$$1,
    { className: classes },
    children
  );
}

FormInputGroup.displayName = "Form.InputGroup";

function FormHelp(_ref) {
  var className = _ref.className,
      children = _ref.children,
      _ref$position = _ref.position,
      position = _ref$position === undefined ? "top" : _ref$position,
      message = _ref.message;

  var classes = classnames("form-help", className);
  return React.createElement(
    "span",
    {
      className: classes,
      dataContent: message,
      dataToggle: "popover",
      dataPlacement: position
    },
    children || "?"
  );
}

FormHelp.displayName = "Form.Help";

function FormSelect(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames({ "form-control": true, "custom-select": true }, className);
  return React.createElement(
    "select",
    { className: classes },
    children
  );
}

FormSelect.displayName = "Form.Select";

function FormFooter(props) {
  var classes = classnames("form-footer", props.className);
  return React.createElement(
    "div",
    { className: classes },
    props.children
  );
}

FormFooter.displayName = "Form.Footer";

var FormRatio = function (_React$PureComponent) {
  inherits(FormRatio, _React$PureComponent);

  function FormRatio() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, FormRatio);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = FormRatio.__proto__ || Object.getPrototypeOf(FormRatio)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      internalValue: !_this.props.onChange ? _this.props.defaultValue : 0
    }, _this.handleOnChange = function (e) {
      if (_this.props.onChange) {
        _this.props.onChange(e);
      } else {
        var _value = Number(e.target.value);
        _this.setState({ internalValue: _value });
      }
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(FormRatio, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          className = _props.className,
          _props$step = _props.step,
          step = _props$step === undefined ? 1 : _props$step,
          _props$min = _props.min,
          min = _props$min === undefined ? 0 : _props$min,
          _props$max = _props.max,
          max = _props$max === undefined ? 0 : _props$max;

      var classes = classnames(className);

      var value = this.props.onChange ? this.props.value : this.state.internalValue;

      return React.createElement(
        Grid.Row,
        { className: classes, alignItems: "center" },
        React.createElement(
          Grid.Col,
          null,
          React.createElement("input", {
            type: "range",
            className: "form-control custom-range",
            step: step,
            min: min,
            max: max,
            onChange: this.handleOnChange,
            value: value
          })
        ),
        React.createElement(
          Grid.Col,
          { auto: true },
          React.createElement("input", {
            type: "number",
            className: "form-control w-8",
            value: value,
            readOnly: true
          })
        )
      );
    }
  }]);
  return FormRatio;
}(React.PureComponent);

FormRatio.displayName = "Form.Ratio";

function FormFieldSet(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("form-fieldset", className);
  return React.createElement(
    "fieldset",
    { className: classes },
    children
  );
}

FormFieldSet.displayName = "Form.FieldSet";

function FormRadio(_ref) {
  var className = _ref.className,
      label = _ref.label,
      value = _ref.value,
      name = _ref.name,
      checked = _ref.checked,
      disabled = _ref.disabled,
      readOnly = _ref.readOnly,
      onChange = _ref.onChange,
      isInline = _ref.isInline;

  var classes = classnames("custom-control custom-radio", { "custom-control-inline": isInline }, className);
  return React.createElement(
    "label",
    { className: classes },
    React.createElement(Form.Input, {
      type: "radio",
      name: name,
      value: value,
      checked: checked,
      className: classes,
      disabled: disabled,
      readOnly: readOnly,
      onChange: onChange
    }),
    React.createElement(
      "span",
      { className: "custom-control-label" },
      label
    )
  );
}

FormRadio.displayName = "Form.Radio";

function FormCheckbox(_ref) {
  var className = _ref.className,
      label = _ref.label,
      value = _ref.value,
      name = _ref.name,
      checked = _ref.checked,
      disabled = _ref.disabled,
      readOnly = _ref.readOnly,
      onChange = _ref.onChange,
      isInline = _ref.isInline;

  var classes = classnames("custom-control custom-checkbox", { "custom-control-inline": isInline }, className);
  return React.createElement(
    "label",
    { className: classes },
    React.createElement(Form.Input, {
      type: "checkbox",
      name: name,
      value: value,
      checked: checked,
      className: classes,
      disabled: disabled,
      readOnly: readOnly,
      onChange: onChange
    }),
    React.createElement(
      "span",
      { className: "custom-control-label" },
      label
    )
  );
}

FormCheckbox.displayName = "Form.Checkbox";

function FormSelectGroup(_ref) {
  var className = _ref.className,
      children = _ref.children,
      pills = _ref.pills,
      canSelectMultiple = _ref.canSelectMultiple;

  var classes = classnames({ selectgroup: true, "w-100": true, "selectgroup-pills": pills }, className);
  return React.createElement(
    "div",
    { className: classes },
    canSelectMultiple ? children.map(function (itm) {
      return React.cloneElement(itm, { type: "checkbox" });
    }) : children
  );
}

FormSelectGroup.displayName = "Form.SelectGroup";

function FormSelectGroupItem(_ref) {
  var className = _ref.className,
      label = _ref.label,
      name = _ref.name,
      value = _ref.value,
      checked = _ref.checked,
      icon = _ref.icon,
      type = _ref.type;

  var classes = classnames({ "selectgroup-item": true }, className);
  var btnClasses = classnames("selectgroup-button", {
    "selectgroup-button-icon": icon
  });
  var outputLabel = icon ? React.createElement(Icon, { name: icon }) : label;
  return React.createElement(
    "label",
    { className: classes },
    type === "checkbox" ? React.createElement("input", {
      type: "checkbox",
      name: name,
      value: value,
      className: "selectgroup-input",
      checked: checked
    }) : React.createElement("input", {
      type: "radio",
      name: name,
      value: value,
      className: "selectgroup-input",
      checked: checked
    }),
    React.createElement(
      "span",
      { className: btnClasses },
      outputLabel
    )
  );
}

FormSelectGroupItem.displayName = "Form.SelectGroupItem";

var FormFileInput = function (_React$Component) {
  inherits(FormFileInput, _React$Component);

  function FormFileInput() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, FormFileInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = FormFileInput.__proto__ || Object.getPrototypeOf(FormFileInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      fileName: ""
    }, _this._handleOnChange = function (event) {
      console.log(event.target.files);
      _this.setState({ fileName: event.target.files[0].name });
      if (_this.props.onChange) {
        _this.props.onChange(event);
      }
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(FormFileInput, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          className = _props.className,
          value = _props.value,
          name = _props.name,
          _props$label = _props.label,
          labelFromProps = _props$label === undefined ? "Choose file" : _props$label,
          disabled = _props.disabled,
          readOnly = _props.readOnly;


      var classes = classnames("custom-file", className);
      var label = this.state.fileName || labelFromProps;
      return React.createElement(
        "div",
        { className: classes },
        React.createElement("input", {
          type: "file",
          className: "custom-file-input",
          name: name,
          value: value,
          disabled: disabled,
          readOnly: readOnly,
          onChange: this._handleOnChange
        }),
        React.createElement(
          "label",
          {
            className: "custom-file-label",
            style: {
              whiteSpace: "nowrap",
              display: "block",
              overflow: "hidden"
            }
          },
          label
        )
      );
    }
  }]);
  return FormFileInput;
}(React.Component);

FormFileInput.displayName = "Form.FileInput";

function FormToggleStack(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("custom-switches-stacked", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

FormToggleStack.displayName = "Form.ToggleStack";

function FormToggle(_ref) {
  var className = _ref.className,
      _ref$type = _ref.type,
      type = _ref$type === undefined ? "checkbox" : _ref$type,
      name = _ref.name,
      value = _ref.value,
      label = _ref.label,
      onChange = _ref.onChange,
      checked = _ref.checked;

  var classes = classnames("custom-switch", className);
  return React.createElement(
    "label",
    { className: classes },
    React.createElement("input", {
      type: type,
      name: name,
      value: value,
      className: "custom-switch-input",
      checked: checked,
      onChange: onChange
    }),
    React.createElement("span", { className: "custom-switch-indicator" }),
    React.createElement(
      "span",
      { className: "custom-switch-description" },
      label
    )
  );
}

FormToggle.displayName = "Form.Toggle";

function FormInputGroupAppend(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames(className);
  return React.createElement(
    FormInputGroup,
    { RootComponent: "span", className: classes, append: true },
    React.createElement(
      "span",
      { className: "input-group-text" },
      children
    )
  );
}

FormInputGroupAppend.displayName = "Form.InputGroupAppend";

function FormInputGroupPrepend(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames(className);
  return React.createElement(
    FormInputGroup,
    { RootComponent: "span", className: classes, prepend: true },
    React.createElement(
      "span",
      { className: "input-group-text" },
      children
    )
  );
}

FormInputGroupPrepend.displayName = "Form.InputGroupPrepend";

function Form(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames(className);
  return React.createElement(
    "form",
    { className: classes },
    children
  );
}

Form.Group = FormGroup;
Form.Label = FormLabel;
Form.Input = FormInput;
Form.StaticText = FormStaticText;
Form.Textarea = FormTextarea;
Form.ImageCheck = FormImageCheck;
Form.ImageCheckItem = FormImageCheckItem;
Form.ColorCheck = FormColorCheck;
Form.ColorCheckItem = FormColorCheckItem;
Form.InputGroup = FormInputGroup;
Form.Help = FormHelp;
Form.Select = FormSelect;
Form.Footer = FormFooter;
Form.Ratio = FormRatio;
Form.FieldSet = FormFieldSet;
Form.SelectGroup = FormSelectGroup;
Form.SelectGroupItem = FormSelectGroupItem;
Form.Radio = FormRadio;
Form.Checkbox = FormCheckbox;
Form.FileInput = FormFileInput;
Form.SwitchStack = FormToggleStack;
Form.Switch = FormToggle;
Form.InputGroupAppend = FormInputGroupAppend;
Form.InputGroupPrepend = FormInputGroupPrepend;

function DropdownTrigger(_ref) {
  var className = _ref.className,
      toggle = _ref.toggle,
      value = _ref.value,
      children = _ref.children,
      _ref$type = _ref.type,
      type = _ref$type === undefined ? "link" : _ref$type,
      icon = _ref.icon,
      color = _ref.color,
      isNavLink = _ref.isNavLink;

  var classes = classnames({ "dropdown-toggle": toggle, "nav-link": isNavLink }, className);

  var childrenFragment = React.createElement(
    React.Fragment,
    null,
    icon && React.createElement(
      React.Fragment,
      null,
      React.createElement(Icon, { name: icon }),
      " "
    ),
    value,
    children
  );

  return type === "link" ? React.createElement(
    "a",
    { className: classes, "data-toggle": "dropdown" },
    childrenFragment
  ) : React.createElement(
    Button,
    { className: classes, color: color, isDropdownToggle: true },
    childrenFragment
  );
}

DropdownTrigger.displayName = "Dropdown.Trigger";

function DropdownMenu(_ref) {
  var _cn;

  var className = _ref.className,
      children = _ref.children,
      _ref$position = _ref.position,
      position = _ref$position === undefined ? "" : _ref$position,
      arrow = _ref.arrow;

  var classes = classnames((_cn = {
    "dropdown-menu": true
  }, defineProperty(_cn, "dropdown-menu-" + position, position), defineProperty(_cn, "dropdown-menu-arrow", arrow), _cn), className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

DropdownMenu.displayName = "Dropdown.Menu";

function DropdownItem(_ref) {
  var className = _ref.className,
      icon = _ref.icon,
      value = _ref.value,
      children = _ref.children,
      badge = _ref.badge,
      to = _ref.to,
      RootComponent = _ref.RootComponent;

  var classes = classnames({ "dropdown-item": true }, className);
  var childrenForAll = React.createElement(
    React.Fragment,
    null,
    badge && React.createElement(
      "span",
      { className: "float-right" },
      React.createElement(
        Badge,
        null,
        badge
      )
    ),
    icon && React.createElement(
      React.Fragment,
      null,
      React.createElement(Icon, { name: icon, className: "dropdown-icon" }),
      " "
    ),
    value,
    children
  );
  return RootComponent ? React.createElement(
    RootComponent,
    { className: classes, to: to },
    childrenForAll
  ) : React.createElement(
    "a",
    { className: classes, href: to },
    childrenForAll
  );
}

DropdownItem.displayName = "Dropdown.Item";

function DropdownItemDivider(props) {
  return React.createElement(
    "div",
    { className: "dropdown-divider" },
    props.children
  );
}

DropdownItemDivider.displayName = "Dropdown.ItemDivider";

function Dropdown(props) {
  var className = props.className,
      children = props.children,
      desktopOnly = props.desktopOnly;


  var classes = classnames({ dropdown: true, "d-none": desktopOnly, "d-md-flex": desktopOnly }, className);

  var trigger = props.trigger || props.triggerContent && React.createElement(
    DropdownTrigger,
    {
      isNavLink: props.isNavLink,
      icon: props.icon,
      type: props.type,
      className: props.triggerClassName
    },
    props.triggerContent
  );

  var items = props.items || props.itemsObject && props.itemsObject.map(function (item) {
    return item.isDivider ? React.createElement(Dropdown.ItemDivider, null) : React.createElement(Dropdown.Item, {
      icon: item.icon,
      badge: item.badge,
      value: item.value
    });
  });

  var menu = (props.items || props.itemsObject) && React.createElement(
    DropdownMenu,
    {
      position: props.position,
      arrow: props.arrow,
      className: props.dropdownMenuClassName
    },
    items
  );

  return React.createElement(
    "div",
    { className: classes },
    trigger,
    menu || children
  );
}

Dropdown.Trigger = DropdownTrigger;
Dropdown.Menu = DropdownMenu;
Dropdown.Item = DropdownItem;
Dropdown.ItemDivider = DropdownItemDivider;

function NavItem(_ref) {
  var children = _ref.children,
      LinkComponent = _ref.LinkComponent,
      value = _ref.value,
      className = _ref.className,
      to = _ref.to,
      _ref$type = _ref.type,
      type = _ref$type === undefined ? "li" : _ref$type,
      icon = _ref.icon,
      hasSubNav = _ref.hasSubNav;

  var childrenForAll = React.createElement(
    React.Fragment,
    null,
    React.createElement(
      Nav.Link,
      {
        className: className,
        to: to,
        icon: icon,
        RootComponent: LinkComponent,
        hasSubNav: hasSubNav
      },
      value
    ),
    hasSubNav ? React.createElement(
      Dropdown.Menu,
      { arrow: true },
      children
    ) : children
  );

  return type === "div" ? React.createElement(
    "div",
    { className: "nav-item" },
    childrenForAll
  ) : React.createElement(
    "li",
    { className: "nav-item" },
    childrenForAll
  );
}

NavItem.displayName = "Nav.Item";

function Icon(_ref) {
  var _cn;

  var _ref$prefix = _ref.prefix,
      prefixFromProps = _ref$prefix === undefined ? "fe" : _ref$prefix,
      name = _ref.name,
      className = _ref.className,
      link = _ref.link,
      isAriaHidden = _ref.isAriaHidden,
      payment = _ref.payment;

  var prefix = payment ? "payment" : prefixFromProps;
  var classes = classnames((_cn = {}, defineProperty(_cn, prefix, true), defineProperty(_cn, prefix + "-" + name, true), _cn), className);
  var extraProps = isAriaHidden ? {
    "aria-hidden": "true"
  } : null;

  return !link ? React.createElement("i", { className: classes }) : React.createElement(
    "a",
    _extends({ className: "icon" }, extraProps),
    React.createElement("i", { className: classes })
  );
}

Icon.displayName = "Icon";

function NavLink(_ref) {
  var children = _ref.children,
      className = _ref.className,
      RootComponent = _ref.RootComponent,
      icon = _ref.icon,
      _ref$active = _ref.active,
      active = _ref$active === undefined ? false : _ref$active,
      to = _ref.to,
      hasSubNav = _ref.hasSubNav;

  var classes = classnames({ "nav-link": true, active: active }, className);

  var childrenForAll = React.createElement(
    React.Fragment,
    null,
    icon && React.createElement(
      React.Fragment,
      null,
      React.createElement(Icon, { name: icon }),
      " "
    ),
    children
  );

  return RootComponent ? React.createElement(
    RootComponent,
    {
      className: classes,
      to: to,
      "data-toggle": hasSubNav && "dropdown"
    },
    childrenForAll
  ) : React.createElement(
    "a",
    { className: classes, href: to, "data-toggle": hasSubNav && "dropdown" },
    childrenForAll
  );
}

NavLink.displayName = "Nav.Link";

function NavSubItem(_ref) {
  var children = _ref.children,
      LinkComponent = _ref.LinkComponent,
      className = _ref.className,
      to = _ref.to,
      icon = _ref.icon,
      hasSubNav = _ref.hasSubNav,
      value = _ref.value;

  return React.createElement(
    Dropdown.Item,
    { to: to, icon: icon, RootComponent: LinkComponent },
    value || children
  );
}

NavSubItem.displayName = "Nav.SubItem";

function NavSubmenu(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames({ nav: true, "nav-submenu": true }, className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

NavSubmenu.displayName = "Nav.Submenu";

function NavSubmenuItem(_ref) {
  var className = _ref.className,
      RootComponent = _ref.RootComponent,
      icon = _ref.icon,
      children = _ref.children,
      _ref$active = _ref.active,
      active = _ref$active === undefined ? false : _ref$active,
      to = _ref.to;

  var classes = classnames({ "nav-item": true, active: active }, className);
  var Component$$1 = RootComponent || "a";
  return React.createElement(
    Component$$1,
    { className: classes, to: to },
    icon && React.createElement(
      React.Fragment,
      null,
      React.createElement(Icon, { name: icon }),
      " "
    ),
    children
  );
}

NavSubmenuItem.displayName = "Nav.SubmenuItem";

function Nav(_ref) {
  var className = _ref.className,
      children = _ref.children,
      _ref$tabbed = _ref.tabbed,
      tabbed = _ref$tabbed === undefined ? true : _ref$tabbed;

  var classes = classnames({ nav: true, "nav-tabs": tabbed }, className);
  return React.createElement(
    "ul",
    { className: classes },
    children
  );
}

Nav.Item = NavItem;
Nav.SubItem = NavSubItem;
Nav.Link = NavLink;
Nav.Submenu = NavSubmenu;
Nav.SubmenuItem = NavSubmenuItem;

function AlertLink(_ref) {
  var children = _ref.children,
      className = _ref.className,
      href = _ref.href;

  var classes = classnames("alert-link", className);
  return React.createElement(
    "a",
    { className: classes, href: href },
    children
  );
}

AlertLink.displayName = "Alert.Link";

function Alert(_ref) {
  var className = _ref.className,
      children = _ref.children,
      type = _ref.type,
      icon = _ref.icon,
      hasExtraSpace = _ref.hasExtraSpace,
      isDismissible = _ref.isDismissible,
      avatar = _ref.avatar;

  var alertClassName = "alert-" + type;
  var classes = classnames("alert", alertClassName, {
    "alert-icon": !!icon,
    "mt-5 mb-6": hasExtraSpace,
    "alert-dismissible": isDismissible,
    "alert-avatar": !!avatar
  }, className);
  return React.createElement(
    "div",
    { className: classes, role: "alert" },
    isDismissible && React.createElement("button", { type: "button", className: "close", "data-dismiss": "alert" }),
    avatar && React.createElement(Avatar, { imageURL: avatar }),
    icon && React.createElement(Icon, { name: icon, className: "mr-2", isAriaHidden: true }),
    children
  );
}

Alert.Link = AlertLink;

function AvatarList(_ref) {
  var className = _ref.className,
      children = _ref.children,
      stacked = _ref.stacked;

  var classes = classnames({
    "avatar-list": true,
    "avatar-list-stacked": stacked
  }, className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

AvatarList.displayName = "Avatar.List";

function Avatar(_ref) {
  var _cn;

  var className = _ref.className,
      children = _ref.children,
      imageURL = _ref.imageURL,
      style = _ref.style,
      _ref$size = _ref.size,
      size = _ref$size === undefined ? "" : _ref$size,
      status = _ref.status,
      placeholder = _ref.placeholder,
      icon = _ref.icon,
      _ref$color = _ref.color,
      color = _ref$color === undefined ? "" : _ref$color;

  var classes = classnames((_cn = {
    avatar: true
  }, defineProperty(_cn, "avatar-" + size, !!size), defineProperty(_cn, "avatar-placeholder", placeholder), defineProperty(_cn, "avatar-" + color, !!color), _cn), className);
  return React.createElement(
    "span",
    {
      className: classes,
      style: imageURL ? Object.assign({
        backgroundImage: "url(" + imageURL + ")"
      }, style) : style
    },
    icon && React.createElement(Icon, { name: icon }),
    status && React.createElement("span", { className: "avatar-status bg-" + status }),
    children
  );
}

Avatar.List = AvatarList;

function Badge(_ref) {
  var className = _ref.className,
      children = _ref.children,
      _ref$color = _ref.color,
      color = _ref$color === undefined ? "primary" : _ref$color;

  var classes = classnames(defineProperty({
    badge: true
  }, "badge-" + color, color), className);
  return React.createElement(
    "span",
    { className: classes },
    children
  );
}

function ButtonList(_ref) {
  var className = _ref.className,
      children = _ref.children,
      _ref$align = _ref.align,
      align = _ref$align === undefined ? "" : _ref$align,
      props = objectWithoutProperties(_ref, ["className", "children", "align"]);

  var classes = classnames(defineProperty({ "btn-list": true }, "text-" + align, !!align), className);
  return React.createElement(
    "div",
    _extends({ className: classes }, props),
    children
  );
}

ButtonList.displayName = "Button.List";

var Button = function Button(props) {
  var _cn;

  var _props$size = props.size,
      size = _props$size === undefined ? "" : _props$size,
      outline = props.outline,
      link = props.link,
      block = props.block,
      className = props.className,
      children = props.children,
      disabled = props.disabled,
      _props$color = props.color,
      color = _props$color === undefined ? "" : _props$color,
      square = props.square,
      pill = props.pill,
      icon = props.icon,
      _props$social = props.social,
      social = _props$social === undefined ? "" : _props$social,
      loading = props.loading,
      isDropdownToggle = props.isDropdownToggle;


  var classes = classnames((_cn = {
    btn: true
  }, defineProperty(_cn, "btn-" + size, !!size), defineProperty(_cn, "btn-block", block), defineProperty(_cn, "btn-outline-" + color, outline && !!color), defineProperty(_cn, "btn-link", link), defineProperty(_cn, "disabled", disabled), defineProperty(_cn, "btn-" + color, !!color && !outline), defineProperty(_cn, "btn-" + social, !!social), defineProperty(_cn, "btn-square", square), defineProperty(_cn, "btn-pill", pill), defineProperty(_cn, "btn-icon", !children), defineProperty(_cn, "btn-loading", loading), defineProperty(_cn, "dropdown-toggle", isDropdownToggle), _cn), className);

  var propsForAll = {
    className: classes,
    disabled: disabled,
    "data-toggle": isDropdownToggle && "dropdown"
  };

  var childrenForAll = React.createElement(
    React.Fragment,
    null,
    social ? React.createElement(Icon, { name: social, prefix: "fa", className: children ? "mr-2" : "" }) : icon ? React.createElement(Icon, { name: icon, className: children ? "mr-2" : "" }) : null,
    children
  );

  if (!props.RootComponent || props.RootComponent === "button") {
    var _type = props.type,
        _value = props.value,
        _onClick = props.onClick;

    return React.createElement(
      "button",
      _extends({}, propsForAll, { type: _type, value: _value, onClick: _onClick }),
      childrenForAll
    );
  } else if (props.RootComponent === "input") {
    var _type2 = props.type,
        _value2 = props.value,
        _onClick2 = props.onClick;


    return React.createElement(
      "input",
      _extends({}, propsForAll, { type: _type2, value: _value2, onClick: _onClick2 }),
      childrenForAll
    );
  } else if (props.RootComponent === "a") {
    var _href = props.href,
        _target = props.target,
        _onClick3 = props.onClick;


    return React.createElement(
      "a",
      _extends({}, propsForAll, { href: _href, target: _target, onClick: _onClick3 }),
      childrenForAll
    );
  } else {
    var _onClick4 = props.onClick,
        _to = props.to;


    var Component$$1 = props.RootComponent;

    return React.createElement(
      Component$$1,
      _extends({}, propsForAll, { to: _to, onClick: _onClick4 }),
      childrenForAll
    );
  }
};

Button.List = ButtonList;

var TextSmall = function TextSmall(_ref) {
  var className = _ref.className,
      children = _ref.children,
      _ref$color = _ref.color,
      color = _ref$color === undefined ? "" : _ref$color,
      wrap = _ref.wrap,
      muted = _ref.muted;

  return React.createElement(
    Text,
    {
      RootComponent: "small",
      color: color,
      size: "sm",
      wrap: wrap,
      className: className,
      muted: muted
    },
    children
  );
};

TextSmall.displayName = "Text.Small";

var Text = function Text(_ref) {
  var _cn;

  var className = _ref.className,
      children = _ref.children,
      RootComponent = _ref.RootComponent,
      _ref$color = _ref.color,
      color = _ref$color === undefined ? "" : _ref$color,
      _ref$size = _ref.size,
      size = _ref$size === undefined ? "" : _ref$size,
      wrap = _ref.wrap,
      muted = _ref.muted,
      props = objectWithoutProperties(_ref, ["className", "children", "RootComponent", "color", "size", "wrap", "muted"]);

  var classes = classnames((_cn = {}, defineProperty(_cn, "text-wrap p-lg-6", wrap), defineProperty(_cn, "text-" + color, color), defineProperty(_cn, "" + size, size), defineProperty(_cn, "text-muted", muted), _cn), className);
  var Component$$1 = RootComponent || "div";
  return React.createElement(
    Component$$1,
    _extends({ className: classes }, props),
    children
  );
};

Text.displayName = "Text";

Text.Small = TextSmall;

function ProgressBar(_ref) {
  var className = _ref.className,
      _ref$color = _ref.color,
      color = _ref$color === undefined ? "" : _ref$color,
      _ref$width = _ref.width,
      width = _ref$width === undefined ? 0 : _ref$width;

  var classes = classnames("progress-bar", defineProperty({}, "bg-" + color, !!color), className);
  return React.createElement("div", { className: classes, style: { width: width + "%" } });
}

ProgressBar.displayName = "Progress.Bar";

function Progress(_ref) {
  var className = _ref.className,
      children = _ref.children,
      _ref$size = _ref.size,
      size = _ref$size === undefined ? "" : _ref$size;

  var classes = classnames("progress", defineProperty({}, "progress-" + size, !!size), className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

Progress.Bar = ProgressBar;

function ProgressCard(_ref) {
  var className = _ref.className,
      header = _ref.header,
      content = _ref.content,
      progressColor = _ref.progressColor,
      progressWidth = _ref.progressWidth;

  var classes = classnames(className);
  return React.createElement(
    Card,
    { className: classes },
    React.createElement(
      Card.Body,
      { className: "text-center" },
      React.createElement(
        Header,
        { size: 5 },
        header
      ),
      React.createElement(
        "div",
        { className: "display-4 font-weight-bold mb-4" },
        content
      ),
      React.createElement(
        Progress,
        { size: "sm" },
        React.createElement(Progress.Bar, { color: progressColor, width: progressWidth })
      )
    )
  );
}

ProgressCard.displayName = "ProgressCard";

function TableHeader(_ref) {
  var className = _ref.className,
      children = _ref.children,
      props = objectWithoutProperties(_ref, ["className", "children"]);

  var classes = classnames(className);
  return React.createElement(
    "thead",
    _extends({ className: classes }, props),
    children
  );
}

TableHeader.displayName = "Table.Header";

function TableBody(_ref) {
  var className = _ref.className,
      children = _ref.children,
      props = objectWithoutProperties(_ref, ["className", "children"]);

  var classes = classnames(className);
  return React.createElement(
    "tbody",
    _extends({ className: classes }, props),
    children
  );
}

TableBody.displayName = "Table.Body";

function TableRow(_ref) {
  var className = _ref.className,
      children = _ref.children,
      props = objectWithoutProperties(_ref, ["className", "children"]);

  var classes = classnames(className);
  return React.createElement(
    "tr",
    _extends({ className: classes }, props),
    children
  );
}

TableRow.displayName = "Table.Row";

function TableCol(_ref) {
  var className = _ref.className,
      children = _ref.children,
      _ref$alignContent = _ref.alignContent,
      alignContent = _ref$alignContent === undefined ? "" : _ref$alignContent;

  var classes = classnames(defineProperty({}, "text-" + alignContent, alignContent), className);
  return React.createElement(
    "td",
    { className: classes },
    children
  );
}

TableCol.displayName = "Table.Col";

function TableColHeader(_ref) {
  var className = _ref.className,
      children = _ref.children,
      colSpan = _ref.colSpan,
      _ref$alignContent = _ref.alignContent,
      alignContent = _ref$alignContent === undefined ? "" : _ref$alignContent;

  var classes = classnames(defineProperty({}, "text-" + alignContent, alignContent), className);
  return React.createElement(
    "th",
    { className: classes, colSpan: colSpan },
    children
  );
}

TableColHeader.displayName = "Table.ColHeader";

function Table(_ref) {
  var className = _ref.className,
      children = _ref.children,
      cards = _ref.cards,
      striped = _ref.striped,
      responsive = _ref.responsive,
      highlightRowOnHover = _ref.highlightRowOnHover,
      hasOutline = _ref.hasOutline,
      verticalAlign = _ref.verticalAlign,
      props = objectWithoutProperties(_ref, ["className", "children", "cards", "striped", "responsive", "highlightRowOnHover", "hasOutline", "verticalAlign"]);

  var classes = classnames("table", {
    "card-table": cards,
    "table-striped": striped,
    "table-hover": highlightRowOnHover,
    "table-outline": hasOutline,
    "table-vcenter": verticalAlign === "center"
  }, className);

  var header = props.headerItems && React.createElement(
    Table.Header,
    null,
    React.createElement(
      Table.Row,
      null,
      props.headerItems.map(function (item, i) {
        return React.createElement(
          Table.ColHeader,
          { key: i, className: item.className },
          item.content
        );
      })
    )
  );

  var body = props.bodyItems && React.createElement(
    Table.Body,
    null,
    props.bodyItems.map(function (row, i) {
      return React.createElement(
        Table.Row,
        null,
        row.map(function (col) {
          return React.createElement(
            Table.Col,
            {
              className: col.className,
              alignContent: col.alignContent
            },
            col.content
          );
        })
      );
    })
  );

  var table = React.createElement(
    "table",
    _extends({ className: classes }, props),
    header,
    body || children
  );

  return !responsive ? table : React.createElement(
    "div",
    { className: "table-responsive" },
    table
  );
}

Table.defaultProps = {
  cards: false,
  striped: false,
  responsive: false
};

Table.Header = TableHeader;
Table.Body = TableBody;
Table.Row = TableRow;
Table.Col = TableCol;
Table.ColHeader = TableColHeader;

function ListItem(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames(className);
  return React.createElement(
    "li",
    { className: classes },
    children
  );
}

ListItem.displayName = "List.Item";

function ListGroup(_ref) {
  var className = _ref.className,
      children = _ref.children,
      transparent = _ref.transparent;

  var classes = classnames("list-group", "mb-0", {
    "list-group-transparent": transparent
  }, className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

ListGroup.displayName = "List.Group";

function ListGroupItem(_ref) {
  var className = _ref.className,
      children = _ref.children,
      RootComponent = _ref.RootComponent,
      active = _ref.active,
      icon = _ref.icon,
      to = _ref.to;

  var classes = classnames("list-group-item", "list-group-item-action", {
    active: active
  }, className);
  // const Component = RootComponent || "a";
  return RootComponent ? React.createElement(
    RootComponent,
    { to: to, className: classes },
    icon && React.createElement(
      "span",
      { className: "mr-3 icon" },
      React.createElement(Icon, { prefix: "fe", name: icon }),
      " "
    ),
    children
  ) : React.createElement(
    "a",
    { className: classes, href: to },
    icon && React.createElement(
      "span",
      { className: "mr-3 icon" },
      React.createElement(Icon, { prefix: "fe", name: icon }),
      " "
    ),
    children
  );
}

ListGroupItem.displayName = "List.GroupItem";

function List(_ref) {
  var className = _ref.className,
      children = _ref.children,
      unstyled = _ref.unstyled,
      seperated = _ref.seperated;

  var classes = classnames({
    list: !unstyled,
    "list-unstyled": unstyled,
    "list-seperated": seperated
  }, className);
  return React.createElement(
    "ul",
    { className: classes },
    children
  );
}

List.Item = ListItem;
List.Group = ListGroup;
List.GroupItem = ListGroupItem;

// GalleryCardDetails Component
function GalleryCardDetails(_ref) {
  var className = _ref.className,
      children = _ref.children,
      avatarURL = _ref.avatarURL,
      fullName = _ref.fullName,
      dateString = _ref.dateString;

  //classes

  var avatarClasses = classnames("mr-3");
  var dateStringClasses = classnames("d-block text-muted");

  //conditions
  var hasOtherDetails = fullName !== null || dateString !== null;

  //components
  var avatar = React.createElement(Avatar, { imageURL: avatarURL, size: "md", className: avatarClasses });
  // TODO: The following could be a seperate component
  var otherDetails = React.createElement(
    "div",
    null,
    React.createElement(
      "div",
      null,
      fullName
    ),
    React.createElement(
      "small",
      { className: dateStringClasses },
      " ",
      dateString
    ),
    " "
  );

  return React.createElement(
    React.Fragment,
    null,
    avatarURL && avatar,
    hasOtherDetails && otherDetails,
    children
  );
}

GalleryCardDetails.displayName = "GalleryCard.Details";

function GalleryCardFooter(_ref) {
  var children = _ref.children;

  var classes = classnames("d-flex", "align-items-center", "px-2");

  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

GalleryCardFooter.displayName = "GalleryCard.Footer";

function GalleryCardIconGroup(_ref) {
  var children = _ref.children,
      className = _ref.className;

  var classes = classnames("ml-auto", "text-muted", className);

  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

GalleryCardIconGroup.displayName = "GalleryCard.IconGroup";

function GalleryCardIconItem(_ref) {
  var className = _ref.className,
      label = _ref.label,
      name = _ref.name,
      href = _ref.href,
      right = _ref.right,
      to = _ref.to,
      RootComponent = _ref.RootComponent;

  var positionRightClasses = "d-none d-md-inline-block ml-3";
  var componentClasses = !right ? classnames("icon", className) : classnames("icon", positionRightClasses, className);

  var iconClasses = classnames("mr-1");

  var childrenForAll = React.createElement(
    React.Fragment,
    null,
    React.createElement(Icon, { name: name, className: iconClasses }),
    label
  );

  var extraProps = {};

  if (href) {
    extraProps.href = href;
  }

  return RootComponent ? React.createElement(
    RootComponent,
    { className: componentClasses, to: to },
    childrenForAll
  ) : React.createElement(
    "a",
    _extends({ className: componentClasses }, extraProps),
    childrenForAll
  );
}

GalleryCardIconItem.displayName = "GalleryCard.IconItem";

function GalleryCardImage(_ref) {
  var src = _ref.src,
      alt = _ref.alt,
      href = _ref.href,
      _ref$rounded = _ref.rounded,
      rounded = _ref$rounded === undefined ? true : _ref$rounded,
      className = _ref.className,
      to = _ref.to,
      RootComponent = _ref.RootComponent;

  var componentClasses = classnames("mb-3");

  var imageClasses = classnames({
    rounded: rounded
  }, className);

  var componentOptionalProps = {};

  if (href) {
    componentOptionalProps.href = href;
  }

  var image = React.createElement("img", { src: src, alt: alt, className: imageClasses });
  return RootComponent ? React.createElement(
    RootComponent,
    { className: componentClasses, to: to },
    image
  ) : React.createElement(
    "a",
    _extends({ className: componentClasses }, componentOptionalProps),
    image
  );
}

GalleryCardImage.displayName = "GalleryCard.Image";

function GalleryCard(_ref) {
  var children = _ref.children,
      className = _ref.className;

  var cardClassName = classnames("p-3", className);
  return React.createElement(
    Card,
    { className: cardClassName },
    children
  );
}

GalleryCard.Details = GalleryCardDetails;
GalleryCard.Footer = GalleryCardFooter;
GalleryCard.IconGroup = GalleryCardIconGroup;
GalleryCard.IconItem = GalleryCardIconItem;
GalleryCard.Image = GalleryCardImage;

function PricingCardCategory(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("card-category", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

PricingCardCategory.displayName = "PricingCard.Category";

// TODO:Add size options


function PricingCardPrice(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("display-3 my-4", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

PricingCardPrice.displayName = "PricingCard.Price";

function PricingCardAttributeList(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames("list-unstyled", "leading-loose", className);
  return React.createElement(
    "ul",
    { className: classes },
    children
  );
}

PricingCardAttributeList.displayName = "PricingCard.AttributeList";

// TODO: Add RootComponent prop


function PricingCardAttributeItem(_ref) {
  var children = _ref.children,
      available = _ref.available,
      hasIcon = _ref.hasIcon;

  var iconClasses = available ? classnames("text-success", "mr-2") : classnames("text-danger", "mr-2");

  return hasIcon ? React.createElement(
    "li",
    null,
    " ",
    React.createElement(Icon, {
      prefix: "fe",
      name: available ? "check" : "x",
      className: iconClasses,
      isAriaHidden: true
    }),
    children
  ) : React.createElement(
    "li",
    null,
    " ",
    children,
    " "
  );
}

PricingCardAttributeItem.displayName = "PricingCard.AttributeItem";

// TODO: Add onClick Event Handler
// TODO : Add  color prop


function PricingCardButton(_ref) {
  var className = _ref.className,
      children = _ref.children,
      RootComponent = _ref.RootComponent,
      active = _ref.active,
      href = _ref.href,
      to = _ref.to,
      onClick = _ref.onClick;

  var classes = classnames("text-center", "mt-6");
  var Component$$1 = RootComponent || "a";
  var componentClasses = classnames("btn", active ? "btn-green" : "btn-secondary", "btn-block", className);

  var otherProps = {};

  if (href) {
    otherProps.href = href;
  }

  if (to) {
    otherProps.to = to;
  }

  if (onClick) {
    otherProps.role = "button";
    otherProps.onClick = onClick;
  }

  return React.createElement(
    "div",
    { className: classes },
    React.createElement(
      Component$$1,
      _extends({ className: componentClasses }, otherProps),
      children
    )
  );
}

PricingCardButton.displayName = "PricingCard.Button";

function PricingCard(_ref) {
  var className = _ref.className,
      children = _ref.children,
      _ref$active = _ref.active,
      active = _ref$active === undefined ? false : _ref$active,
      category = _ref.category;

  var cardBodyClassName = classnames("text-center");
  var cardStatusClassName = classnames("card-status", "bg-green");
  var cardStatus = React.createElement("div", { className: cardStatusClassName });
  var cardCategory = React.createElement(
    PricingCardCategory,
    null,
    category
  );
  // TODO: Add component logic.
  return React.createElement(
    Card,
    null,
    active && cardStatus,
    React.createElement(
      Card.Body,
      { className: cardBodyClassName },
      category && cardCategory,
      children
    )
  );
}

PricingCard.Category = PricingCardCategory;
PricingCard.Price = PricingCardPrice;
PricingCard.AttributeList = PricingCardAttributeList;
PricingCard.AttributeItem = PricingCardAttributeItem;
PricingCard.Button = PricingCardButton;

function StoreCard(_ref) {
  var children = _ref.children,
      title = _ref.title,
      subtitle = _ref.subtitle,
      price = _ref.price,
      imgUrl = _ref.imgUrl,
      imgAlt = _ref.imgAlt;

  return React.createElement(
    Card,
    null,
    React.createElement(
      Card.Body,
      null,
      React.createElement(
        "div",
        { className: "mb-4 text-center" },
        React.createElement("img", { src: imgUrl, alt: imgAlt })
      ),
      React.createElement(
        Card.Title,
        null,
        title
      ),
      React.createElement(
        Text,
        { className: "card-subtitle" },
        subtitle
      ),
      React.createElement(
        "div",
        { className: "mt-5 d-flex align-items-center" },
        React.createElement(
          "div",
          { className: "product-price" },
          React.createElement(
            "strong",
            null,
            price
          )
        ),
        React.createElement(
          "div",
          { className: "ml-auto" },
          React.createElement(
            Button,
            { className: "btn-primary" },
            React.createElement(Icon, { className: "fe-plus" }),
            "Add to cart"
          )
        )
      )
    )
  );
}

function StatsCard(_ref) {
  var className = _ref.className,
      movement = _ref.movement,
      total = _ref.total,
      label = _ref.label,
      _ref$layout = _ref.layout,
      layout = _ref$layout === undefined ? 1 : _ref$layout,
      chart = _ref.chart;

  var classes = classnames(className);
  var movementString = "" + (movement > 0 ? "+" : "") + movement + "%";
  var movementColor = !movement ? "yellow" : movement > 0 ? "green" : "red";
  if (layout === 2) {
    return React.createElement(
      Card,
      { className: classes },
      React.createElement(
        Card.Body,
        null,
        React.createElement(
          "div",
          { className: "card-value float-right text-" + movementColor },
          movementString
        ),
        React.createElement(
          Header.H3,
          { className: "mb-1" },
          total
        ),
        React.createElement(
          Text,
          { muted: true },
          label
        )
      ),
      chart && React.createElement(
        "div",
        { className: "card-chart-bg" },
        chart
      )
    );
  }

  return React.createElement(
    Card,
    { className: classes },
    React.createElement(
      Card.Body,
      { className: "p-3 text-center" },
      React.createElement(
        Text,
        { color: movementColor, className: "text-right" },
        movementString,
        React.createElement(Icon, {
          name: !movement ? "minus" : movement > 0 ? "chevron-up" : "chevron-down"
        })
      ),
      React.createElement(
        Header,
        { className: "m-0" },
        total
      ),
      React.createElement(
        Text,
        { color: "muted", className: " mb-4" },
        label
      )
    )
  );
}

StatsCard.displayName = "StatsCard";

function Stamp(_ref) {
  var _cn;

  var children = _ref.children,
      className = _ref.className,
      _ref$size = _ref.size,
      size = _ref$size === undefined ? "md" : _ref$size,
      icon = _ref.icon,
      _ref$color = _ref.color,
      color = _ref$color === undefined ? "" : _ref$color;

  var classes = classnames((_cn = { stamp: true }, defineProperty(_cn, "stamp-" + size, size), defineProperty(_cn, "bg-" + color, color), _cn), className);
  return React.createElement(
    "span",
    { className: classes },
    icon && React.createElement(Icon, { name: icon }),
    children
  );
}

Stamp.displayName = "Stamp";

function StampCard(_ref) {
  var children = _ref.children,
      className = _ref.className,
      icon = _ref.icon,
      _ref$color = _ref.color,
      color = _ref$color === undefined ? "" : _ref$color,
      header = _ref.header,
      footer = _ref.footer;

  var classes = classnames("p-3", className);
  return React.createElement(
    Card,
    { className: classes },
    React.createElement(
      "div",
      { className: "d-flex align-items-center" },
      React.createElement(Stamp, { color: color, icon: icon, className: "mr-3" }),
      React.createElement(
        "div",
        null,
        header && React.createElement(
          Header.H4,
          { className: "m-0" },
          header
        ),
        children,
        footer && React.createElement(
          Text.Small,
          { muted: true },
          footer
        )
      )
    )
  );
}

StampCard.displayName = "StampCard";

function DimmerContent(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames({ "dimmer-content": true }, className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

DimmerContent.displayName = "Dimmer.Content";

function Dimmer(_ref) {
  var className = _ref.className,
      children = _ref.children,
      active = _ref.active,
      loader = _ref.loader;

  var classes = classnames({ dimmer: true, active: active }, className);
  return React.createElement(
    "div",
    { className: classes },
    React.createElement(
      React.Fragment,
      null,
      loader && React.createElement(Loader, null),
      React.createElement(
        DimmerContent,
        null,
        children
      )
    )
  );
}

Dimmer.displayName = "Dimmer";

Dimmer.Content = DimmerContent;

function Loader(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var classes = classnames({ loader: true }, className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

Loader.displayName = "Loader";

function TagList(props) {
  var children = props.children,
      className = props.className;

  var classes = classnames("tags", className);
  return React.createElement(
    "div",
    { className: classes },
    children
  );
}

TagList.displayName = "Tag.List";

function TagAddOn(props) {
  var children = props.children,
      className = props.className,
      icon = props.icon,
      _props$color = props.color,
      color = _props$color === undefined ? "" : _props$color;

  var classes = classnames("tag-addon", defineProperty({}, "tag-" + color, color), className);

  var childrenForAll = React.createElement(
    React.Fragment,
    null,
    icon && React.createElement(Icon, { name: icon }),
    children
  );

  if (props.link) {
    var _href = props.href,
        _onClick = props.onClick;

    return React.createElement(
      "a",
      { className: classes, href: _href, onClick: _onClick },
      childrenForAll
    );
  }

  if (props.RootComponent) {
    var Component$$1 = props.RootComponent,
        _to = props.to;

    return React.createElement(
      Component$$1,
      { to: _to },
      childrenForAll
    );
  }

  return React.createElement(
    "span",
    { className: classes },
    childrenForAll
  );
}

TagAddOn.displayName = "Tag.AddOn";

function Tag(props) {
  var children = props.children,
      className = props.className,
      rounded = props.rounded,
      _props$color = props.color,
      color = _props$color === undefined ? "" : _props$color,
      avatar = props.avatar,
      remove = props.remove,
      addOn = props.addOn,
      addOnIcon = props.addOnIcon,
      addOnColor = props.addOnColor;

  var classes = classnames(defineProperty({
    tag: true,
    expanded: true,
    "tag-rounded": rounded
  }, "tag-" + color, color), className);
  var childrenForAll = React.createElement(
    React.Fragment,
    null,
    avatar && React.createElement("span", {
      "class": "tag-avatar avatar",
      style: { backgroundImage: "url(" + avatar + ")" }
    }),
    children,
    (addOn || addOnIcon) && React.createElement(
      TagAddOn,
      { icon: addOnIcon, color: addOnColor },
      addOn
    ),
    remove && React.createElement(TagAddOn, { link: true, icon: "x" })
  );

  if (props.RootComponent) {
    var Component$$1 = props.RootComponent,
        _to = props.to;

    return React.createElement(
      Component$$1,
      { className: classes, to: _to },
      childrenForAll
    );
  }

  if (props.link) {
    var _href = props.href;

    return React.createElement(
      "a",
      { className: classes, href: _href },
      childrenForAll
    );
  }

  return React.createElement(
    "span",
    { className: classes },
    childrenForAll
  );
}

Tag.displayName = "Tag";

Tag.List = TagList;
Tag.AddOn = TagAddOn;

function StandaloneFormPage(props) {
  return React.createElement(
    "div",
    { className: "page" },
    React.createElement(
      "div",
      { className: "page-single" },
      React.createElement(
        "div",
        { className: "container" },
        React.createElement(
          "div",
          { className: "row" },
          React.createElement(
            "div",
            { className: "col col-login mx-auto" },
            React.createElement(
              "div",
              { className: "text-center mb-6" },
              React.createElement("img", { src: "./assets/brand/tabler.svg", className: "h-6", alt: "" })
            ),
            props.children
          )
        )
      )
    )
  );
}

function DefaultErrorPage(props) {
  var _onBackClick = function _onBackClick(event) {
    window.history.back();
    event.preventDefault();
    return true;
  };

  var title = props.title,
      subtitle = props.subtitle,
      details = props.details;

  return React.createElement(
    Page,
    { className: "text-center" },
    React.createElement(
      Container,
      null,
      React.createElement(
        Header.H1,
        { className: "display-1 text-muted mb-5" },
        title
      ),
      React.createElement(
        Header.H2,
        null,
        subtitle
      ),
      details && React.createElement(
        Header.H4,
        { className: "text-muted font-weight-normal mb-7" },
        details
      ),
      React.createElement(
        Button,
        { onClick: _onBackClick, className: "btn-primary" },
        React.createElement(Icon, { className: "mr-2", name: "arrow-left" }),
        "Go back"
      )
    )
  );
}

function FormCard(props) {
  return React.createElement(
    Form,
    { className: "card" },
    React.createElement(
      Card.Body,
      { className: "p-6" },
      React.createElement(
        Card.Title,
        { RootComponent: "div" },
        props.title
      ),
      props.children,
      React.createElement(
        Form.Footer,
        null,
        React.createElement(
          Button,
          { color: "primary", block: true },
          props.buttonText
        )
      )
    )
  );
}

var FormTextInput = function (_React$PureComponent) {
  inherits(FormTextInput, _React$PureComponent);

  function FormTextInput() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, FormTextInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = FormTextInput.__proto__ || Object.getPrototypeOf(FormTextInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      value: ""
    }, _this._handleChange = function (event) {
      _this.setState({ value: event.target.value });
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(FormTextInput, [{
    key: "render",
    value: function render() {
      var type = this.props.type || "text";
      var _props = this.props,
          label = _props.label,
          placeHolder = _props.placeHolder;
      var value = this.state.value;

      return React.createElement(
        Form.Group,
        { label: label },
        React.createElement(Form.Input, {
          onChange: this._handleChange,
          placeholder: placeHolder,
          type: type,
          value: value
        })
      );
    }
  }]);
  return FormTextInput;
}(React.PureComponent);

var FormCheckboxInput = function (_React$PureComponent) {
  inherits(FormCheckboxInput, _React$PureComponent);

  function FormCheckboxInput() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, FormCheckboxInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = FormCheckboxInput.__proto__ || Object.getPrototypeOf(FormCheckboxInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      value: false
    }, _this._handleChange = function (event) {
      _this.setState(function (prevState, _) {
        return {
          value: !prevState.value
        };
      });
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(FormCheckboxInput, [{
    key: "render",
    value: function render() {
      var label = this.props.label;
      var value = this.state.value;

      return React.createElement(
        Form.Group,
        null,
        React.createElement(
          "label",
          { className: "custom-control custom-checkbox" },
          React.createElement(Form.Input, {
            type: "checkbox",
            onChange: this._handleChange,
            value: value
          }),
          React.createElement(
            "span",
            { className: "custom-control-label" },
            label
          )
        )
      );
    }
  }]);
  return FormCheckboxInput;
}(React.PureComponent);

// @ flow
var colors = {
  blue: "#467fcf",
  "blue-darkest": "#0e1929",
  "blue-darker": "#1c3353",
  "blue-dark": "#3866a6",
  "blue-light": "#7ea5dd",
  "blue-lighter": "#c8d9f1",
  "blue-lightest": "#edf2fa",
  azure: "#45aaf2",
  "azure-darkest": "#0e2230",
  "azure-darker": "#1c4461",
  "azure-dark": "#3788c2",
  "azure-light": "#7dc4f6",
  "azure-lighter": "#c7e6fb",
  "azure-lightest": "#ecf7fe",
  indigo: "#6574cd",
  "indigo-darkest": "#141729",
  "indigo-darker": "#282e52",
  "indigo-dark": "#515da4",
  "indigo-light": "#939edc",
  "indigo-lighter": "#d1d5f0",
  "indigo-lightest": "#f0f1fa",
  purple: "#a55eea",
  "purple-darkest": "#21132f",
  "purple-darker": "#42265e",
  "purple-dark": "#844bbb",
  "purple-light": "#c08ef0",
  "purple-lighter": "#e4cff9",
  "purple-lightest": "#f6effd",
  pink: "#f66d9b",
  "pink-darkest": "#31161f",
  "pink-darker": "#622c3e",
  "pink-dark": "#c5577c",
  "pink-light": "#f999b9",
  "pink-lighter": "#fcd3e1",
  "pink-lightest": "#fef0f5",
  red: "#e74c3c",
  "red-darkest": "#2e0f0c",
  "red-darker": "#5c1e18",
  "red-dark": "#b93d30",
  "red-light": "#ee8277",
  "red-lighter": "#f8c9c5",
  "red-lightest": "#fdedec",
  orange: "#fd9644",
  "orange-darkest": "#331e0e",
  "orange-darker": "#653c1b",
  "orange-dark": "#ca7836",
  "orange-light": "#feb67c",
  "orange-lighter": "#fee0c7",
  "orange-lightest": "#fff5ec",
  yellow: "#f1c40f",
  "yellow-darkest": "#302703",
  "yellow-darker": "#604e06",
  "yellow-dark": "#c19d0c",
  "yellow-light": "#f5d657",
  "yellow-lighter": "#fbedb7",
  "yellow-lightest": "#fef9e7",
  lime: "#7bd235",
  "lime-darkest": "#192a0b",
  "lime-darker": "#315415",
  "lime-dark": "#62a82a",
  "lime-light": "#a3e072",
  "lime-lighter": "#d7f2c2",
  "lime-lightest": "#f2fbeb",
  green: "#5eba00",
  "green-darkest": "#132500",
  "green-darker": "#264a00",
  "green-dark": "#4b9500",
  "green-light": "#8ecf4d",
  "green-lighter": "#cfeab3",
  "green-lightest": "#eff8e6",
  teal: "#2bcbba",
  "teal-darkest": "#092925",
  "teal-darker": "#11514a",
  "teal-dark": "#22a295",
  "teal-light": "#6bdbcf",
  "teal-lighter": "#bfefea",
  "teal-lightest": "#eafaf8",
  cyan: "#17a2b8",
  "cyan-darkest": "#052025",
  "cyan-darker": "#09414a",
  "cyan-dark": "#128293",
  "cyan-light": "#5dbecd",
  "cyan-lighter": "#b9e3ea",
  "cyan-lightest": "#e8f6f8",
  gray: "#868e96",
  "gray-darkest": "#1b1c1e",
  "gray-darker": "#36393c",
  "gray-light": "#aab0b6",
  "gray-lighter": "#dbdde0",
  "gray-lightest": "#f3f4f5",
  "gray-dark": "#343a40",
  "gray-dark-darkest": "#0a0c0d",
  "gray-dark-darker": "#15171a",
  "gray-dark-dark": "#2a2e33",
  "gray-dark-light": "#717579",
  "gray-dark-lighter": "#c2c4c6",
  "gray-dark-lightest": "#ebebec"
};

exports.StandaloneFormPage = StandaloneFormPage;
exports.DefaultErrorPage = DefaultErrorPage;
exports.FormCard = FormCard;
exports.FormTextInput = FormTextInput;
exports.FormCheckboxInput = FormCheckboxInput;
exports.colors = colors;
exports.Container = Container;
exports.Grid = Grid;
exports.Header = Header;
exports.Site = Site;
exports.Card = Card;
exports.Page = Page;
exports.Form = Form;
exports.Nav = Nav;
exports.Alert = Alert;
exports.Icon = Icon;
exports.Avatar = Avatar;
exports.Badge = Badge;
exports.Dropdown = Dropdown;
exports.Button = Button;
exports.Text = Text;
exports.Progress = Progress;
exports.ProgressCard = ProgressCard;
exports.Table = Table;
exports.List = List;
exports.GalleryCard = GalleryCard;
exports.PricingCard = PricingCard;
exports.StoreCard = StoreCard;
exports.StatsCard = StatsCard;
exports.Stamp = Stamp;
exports.StampCard = StampCard;
exports.Dimmer = Dimmer;
exports.Loader = Loader;
exports.Tag = Tag;
